function [sheet_text,sheet_value]=clean_sheet(sheet)

// PURPOSE: remove empty lines and columns from a sheet 
// imported from Excel and give the coresponding extracted
// values and text tabs
// ------------------------------------------------------------
// INPUT:
// * sheet = a sheet imported from Excel
// ------------------------------------------------------------
// OUTPUT:
// * sheet_text = the clean sheet text field
// * sheet_value = the clean sheet value field
// ------------------------------------------------------------
// Copyright: Eric Dubois 2014-2015
// http://dubois.ensae.net/grocer.html

sheet_text=sheet.text
sheet_value=sheet.value
[nrows,ncols]=size(sheet_text)
while nrows > 1 & isempty(sheet_text(nrows,:)) & and(isnan(sheet_value(nrows,:)))
   nrows=nrows-1
end

while ncols > 1 & (isempty(sheet_text(:,ncols)) | and(isnan(sheet_value(:,ncols))))
    ncols=ncols-1
end

startrows=1
while startrows < nrows-1 & isempty(sheet_text(startrows,:)) & and(isnan(sheet_value(startrows,:)))
   startrows=startrows+1
end

startcols=1
while startcols < ncols-1 & isempty(sheet_text(:,startcols)) & and(isnan(sheet_value(:,startcols)))
   startcols=startcols+1
end
sheet_text=sheet_text(startrows:nrows,startcols:ncols)
sheet_value=sheet_value(startrows:nrows,startcols:ncols)

endfunction