function [true_obj,ind_obj_def,vi]=findobject(vi,obj,before,after,suppr_blank)

// PURPOSE: find the command obj in the string vi
// ------------------------------------------------------------
// INPUT:
// * vi = a string
// * obj = a string to seacrh in vi
// * before = a string vector: what character must be found
//   before vi
// * after = a string vector: what character must be found
//   after vi
// * suppr_blank = a booelan indicating whether blanks count
//   or not
// ------------------------------------------------------------
// OUTPUT:
// * true_obj = a booelan indicating if the object has been 
//   found
// * ind_obj = a row vector, the indexes of the object in the
//   string 
// * vi = the original string, eventually with blanks after the 
//   keyword suppressed 
// ------------------------------------------------------------
// Copyright: Eric Dubois 2009-2010
// http://dubois.ensae.net/grocer.html

ind_obj = strindex(vi,obj)
true_obj=%f
ind_obj_def=[]
length_obj=length(obj)
wi=' '+vi

if ~isempty(ind_obj) then
   for i=size(ind_obj,'*'):-1:1
      ind_obji=ind_obj(i)
      if suppr_blank & ind_obji+length_obj-1 ~= length(vi) then
         // suppress all blanks after the searched keyword
         while ind_obji+length_obj <= length(vi) & part(vi,ind_obji+length_obj) == ' ' then
            vi=part(vi,1:ind_obji+length_obj-1)+part(vi,ind_obji+length_obj+1:length(vi))
         end
      end          
      ind_afterobji=part(vi,ind_obji+length_obj)
      if isempty(after) then
      // any char after the one searched is accepted: set after to the char after the one searched 
    	 after=ind_afterobji
      end
      
      // check if obj is not part of the name of some variable
      if ind_obji == 1 & or(ind_afterobji == after) then
         true_obj=%t
         ind_obj_def=[ind_obji ind_obj_def ]   
      else
         if isempty(before) then
            // any char before the one searched is accepted: set before to the char after the one searched 
	        before=part(wi,ind_obji)
         end
	     if or(part(wi,ind_obji) == before) & or(ind_afterobji == after) then
            true_obj=%t
            ind_obj_def=[ind_obji ind_obj_def]   
         end
      end
   end
end

endfunction
