function johansen_d()
 
global GROCERDIR;
bounds()
 
load(GROCERDIR+'\data\juselius.dat')
 
disp('************')
disp('fig 3.3 p.41')
disp('************')
disp(' ')
pltseries('dnk_Lm3n-dnk_Lpy','window=1')
pltseries('dnk_Lyr','window=2')
pltseries('dnk_Rb','window=3')
pltseries('dnk_Rm','window=4')
pltseries('dnk_DLpy','window=5')
 
q1=seasdummy(['1973q1';'2003q1'],1)-0.25
q2=seasdummy(['1973q1';'2003q1'],2)-0.25
q3=seasdummy(['1973q1';'2003q1'],3)-0.25
 
 
disp('************')
disp('Table 4.1 p.60')
disp('************')
disp(' ')
VAR(2,'endo=dnk_Lm3n-dnk_Lpy;dnk_Lyr;dnk_DLpy;dnk_Rm;dnk_Rb','exo=q1;q2;q3')
 
// create dummies used for regression p.111-112
post83q1=dummy(['1973q1';'2003q1'],['1983q1';'2003q1']);
dum75q4=dummy(['1973q1';'2003q1'],'1975q4')-0.5*dummy(['1973q1';'2003q1'],['1976q1';'1976q2']);
dum76q4=dummy(['1973q1';'2003q1'],'1976q4');
dum83q2=dummy(['1973q1';'2003q1'],'1983q2');
dum83q1=dummy(['1973q1';'2003q1'],'1983q1');
 
disp('************')
disp('fig 6.3 p.109')
disp('************')
disp(' ')
pltseries('dnk_Lm3n-dnk_Lpy','dnk_Lm3rC')
 
disp('************')
disp('table 6.3 p.112')
disp('************')
disp(' ')
VAR(1,'endo=delts(dnk_Lm3rC);delts(dnk_Lyr);delts(dnk_DLpy);delts(dnk_Rm);delts(dnk_Rb)',...
'exo=lagts(dnk_Lm3rC);lagts(dnk_Lyr);lagts(dnk_DLpy);lagts(dnk_Rm);lagts(dnk_Rb);...
lagts(post83q1);trend^1;dum75q4;dum76q4;dum83q1;dum83q2')
 
disp('************')
disp('table 8.1 p. 144')
disp('************')
disp(' ')
rj1=johansen(1,'dnk_Lm3rC','dnk_Lyr','dnk_DLpy','dnk_Rm','dnk_Rb',...
'exo_lt=trend^1;post(1983q1)','exo_st=const;dum75q4;dum76q4;dum83q1')
 
// display the cointegration vectors
prtjohvec(rj1,5)
 
disp('************')
disp('normalize cointegration vectors as done in table 7.1 p. 123')
disp('************')
disp(' ')
rj1b=johansen_normalize(rj1,[3,1,4,2,5])
 
disp('************')
disp('test not in the book: tests of the inclusion of the trend in the')
disp('cointegration vectors')
disp('************')
disp(' ')
r_test_exolt=johansen_test_exo_lt(rj1,2,'trend')
 
disp('************')
disp(' tests p.181')
disp('************')
disp(' ')
// caution: the order of the trend and the dummy are not the same
// H1
disp('hypothesis H1')
disp('************')
disp(' ')
H1=zeros(7,6);
for i=1:5
   H1(i,i)=1;
end
H1(7,6)=1
rjtest1=johansen_common_beta(rj1,3,H1)
// normalize the cointegrating vectors as in Juselius
rjtest1n=johansen_normalize(rjtest1,[3;1;4])
// print the -now normalized- first 3 cintegrating vectors
// prtjohvec(rjtest1n,3)
 
// H2
disp(' ')
disp('hypothesis H2')
disp('************')
disp(' ')
H2=zeros(7,6)
for i=1:6
   H2(i,i)=1
end
rjtest2=johansen_common_beta(rj1,3,H2)
// normalize the cointegrating vectors as in Juselius
rjtest2n=johansen_normalize(rjtest2,[3;1;4])
// print the -now normalized- first 3 cointegrating vectors
// prtjohvec(rjtest2n,3)
 
 
disp('************')
disp('table 10.3 p.188')
disp('************')
disp(' ')
 
disp('first remove the trend from the cointegrating relation')
rj2=johansen(1,'dnk_Lm3rC','dnk_Lyr','dnk_DLpy','dnk_Rm','dnk_Rb',...
'exo_lt=post(1983q1)','exo_st=const;dum75q4;dum76q4;dum83q1')
disp(' ')
disp('hypothesis H7')
disp('************')
disp(' ')
b=[0;0;1;0;0;0]
rjtest7=johansen_known_beta(rj2,3,b)
 
disp(' ')
disp('hypothesis H8')
disp('************')
disp(' ')
b=[0;0;0;1;0;0]
rjtest8=johansen_known_beta(rj2,3,b)
// H9 p.188
b=[0;0;0;0;1;0]
 
disp(' ')
disp('hypothesis H10')
disp('************')
disp(' ')
b=[0;0;1;-1;0;0]
rjtest10=johansen_known_beta(rj2,3,b)
 
disp(' ')
disp('hypothesis H11')
disp('************')
disp(' ')
b=[0;0;1;0;-1;0]
rjtest11=johansen_known_beta(rj2,3,b)
 
disp(' ')
disp('hypothesis H12')
disp('************')
disp(' ')
b=[0;0;0;1;-1;0]
rjtest12=johansen_known_beta(rj2,3,b)
 
disp(' ')
disp('hypothesis H13')
disp('************')
disp(' ')
H1=zeros(6,2);
H1(1,1)=1;
H1(2,1)=-1;
H1(6,2)=1
rjtest13=johansen_beta_part(rj2,3,H1)
 
disp(' ')
disp('hypothesis H17')
disp('************')
disp(' ')
H1=zeros(6,3)
H1(2,1)=1
H1(3,2)=1
H1(6,3)=1
rjtest17=johansen_beta_part(rj2,3,H1)
 
disp(' ')
disp('hypothesis H22')
disp('************')
disp(' ')
H1=zeros(6,2)
H1(3,1)=1
H1(4,1)=-1
H1(6,2)=1
rjtest22=johansen_beta_part(rj2,3,H1)
 
disp(' ')
disp('table 11.1 p.197 - case of the monney demand with 3 cointegration relations')
disp('************')
disp(' ')
rjtest23=johansen_test_lr_weakexo(rj2,3,'dnk_Lm3rC')
 
disp(' ')
disp('test of pages 196-197 that y and Rb are both weakly exogenous')
disp('************')
disp(' ')
rjtest24=johansen_test_lr_weakexo(rj2,3,['dnk_Lyr' 'dnk_Rb'])
 
disp(' ')
disp('test of pages 202: case of mr')
disp('************')
disp(' ')
rjtest25=johansen_known_alpha(rj2,3,[1 0 0 0 0]')
 
disp(' ')
disp('test of pages 202: case of Lyr')
disp('************')
disp(' ')
rjtest26=johansen_known_alpha(rj2,3,[0 1 0 0 0]')
 
disp(' ')
disp('test of pages 202: case of DLpy')
disp('************')
disp(' ')
rjtest27=johansen_known_alpha(rj2,3,[0 0 1 0 0]')
 
disp(' ')
disp('test of pages 202: case of Rm')
disp('************')
disp(' ')
rjtest28=johansen_known_alpha(rj2,3,[0 0 0 1 0]')
 
disp(' ')
disp('test of pages 202: case of Rb')
disp('************')
disp(' ')
rjtest29=johansen_known_alpha(rj2,3,[0 0 0 0 1]')
 
endfunction
