function grocer_H=hessian(grocer_func,grocer_p,varargin)
 
// PURPOSE: Computes finite symmetric difference Hessian
// ------------------------------------------------------------
// INPUT:
// * grocer_func = name of the function
// * grocer_p = point where to evaluate the function
// * vararagin = arguments other than p of funtion func
// ------------------------------------------------------------
// OUTPUT:
// * grocer_H = value of the hessian of func at point p
// ------------------------------------------------------------
// Copyright: Eric Dubois 2002
 
grocer_n = size(grocer_p,1);
 
// Compute the stepsize (h)
//grocer_h = max(1e-3*abs(grocer_p),sqrt(%eps));
grocer_h = %eps^(1/4)*grocer_p+sqrt(%eps)*(grocer_p==0)
grocer_ph = grocer_p+grocer_h;
grocer_h = grocer_ph-grocer_p;
%v$1 = 1:grocer_n;%v$1=%v$1(:);
%v$2 = 1:grocer_n;%v$2=%v$2(:);
grocer_ee = sparse([%v$1,%v$2],grocer_h,[grocer_n,grocer_n]);
 
grocer_H=grocer_h*grocer_h';
for grocer_i=1:grocer_n
   for grocer_j=grocer_i:grocer_n
      grocer_H(grocer_i,grocer_j) = (grocer_func(grocer_p+grocer_ee(:,grocer_i)+grocer_ee(:,grocer_j),varargin(:))-...
          grocer_func(grocer_p-grocer_ee(:,grocer_i)+grocer_ee(:,grocer_j),varargin(:))-...
          grocer_func(grocer_p+grocer_ee(:,grocer_i)-grocer_ee(:,grocer_j),varargin(:))+...
          grocer_func(grocer_p-grocer_ee(:,grocer_i)-grocer_ee(:,grocer_j),varargin(:)))/grocer_H(grocer_i,grocer_j)/4;
      grocer_H(grocer_j,grocer_i) = grocer_H(grocer_i,grocer_j);
   end
end
endfunction
