function pltdma_expnbvar(res)
    
// PURPOSE: plots the number of expected variables over time
// ------------------------------------------------------------
// INPUT:
// * res = the results typed tlist from a DMA estimation
// ------------------------------------------------------------
// OUTPUT:
// nothing: all results are plotted on a news graphing window
// ------------------------------------------------------------
// Copyright: Eric Dubois 2012
// http://dubois.ensae.net/grocer.html


expnbvar=res('exp # of models')
grocer_win=max(winsid())+1
if res('prests') then
   boun=res('bounds')
   dat=[]
   for j=1:size(boun,1)/2
      [bn1,fq]=date2num_fq(boun(2*(j-1)+1))
      bn2=date2num(boun(2*j))
      dat=[dat ; bn1:bn2]
   end
   expnbvar=tlist(['ts';'freq';'dates';'series'],fq,dat,expnbvar)
end

pltseries('expnbvar','title=expected number of predictors',...
                'noleg','window='+string(grocer_win))


endfunction