function prt_reliab(res,out)
 
// PURPOSE: prints the results of a reliability diagnostic
// ------------------------------------------------------------
// INPUT:
// * res = the results typed list of a reliability diagnostic
// * out = the symobolic name of the file where the
//              results are printed (default: %io(2))
// ------------------------------------------------------------
// OUPTUT:
// nothing: all results are printed on the specified file
// ------------------------------------------------------------
// Copyright: Eric Dubois 2002-2006
 
[nargout,nargin] = argn(0)
if nargin == 1 then
   out=%io(2)
end

write(out,'reliability tests:')
write(out,'------------------')
if typeof(res) == 'string' then
   disp(' ')
   write(out,res) 
else
   m2prt=['variable' 'reliability' ; ' ' ' ' ; ...
   res('namex') string(res('reliab')) ]
   disp(' ')
   printmat(m2prt,out)
   end 
endfunction
