function [op,ind_fuspar,ind_fusbrack,ind_nonempty]=Scilab_ind_operators(equation)
  
// PURPOSE: store in a tlist the indexes of selected operators
// of an equation that can be run under Scilab
// ------------------------------------------------------------
// INPUT:
// * equation = a equation dissected between string and non
//   string components
// ------------------------------------------------------------
// OUTPUT:
// * op = a tlist with each field corresponding to an operator
//   op(i) = a (4 x p) matrix:
//   - first line: the positions of the operator
//   - second line: the equation number where the operator
//     appears
//   - third line: the position of the operator end
//   - fourth line: the precedence of the operator, derived by 
//     myself
// * ind_nonempty = vector of non empty operator fields
// ------------------------------------------------------------
// Copyright Eric Dubois 2011
// http://dubois.ensae.net/grocer.html


[ind_leftpar,ind_rightpar,ind_fuspar]=sci_find_parenth(equation,['(';')'],11)
[ind_leftbrack,ind_rightbrack,ind_fusbrack]=sci_find_parenth(equation,['[';']'],12)

//ind_bookkeep_transp=sci_find_simple(equation,'.''',ind_bookkeep_transp,90)
//ind_transp=sci_find_simple(equation,'''',ind_transp,90)
//ind_fact=sci_find_simple(equation,'!',ind_fact,89)
ind_power=sci_find_simple(equation,'.^',85)
ind_hat=sci_find_simple(equation,'^',85)
//ind_startilde=sci_find_simple(equation,'*~',ind_startilde,80)
//ind_kron=sci_find_simple(equation,'.*.',ind_kron,80)
ind_matmul=sci_find_simple(equation,'.*',80)
ind_star=sci_find_simple(equation,'*',80)
ind_matdiv=sci_find_simple(equation,'./',80)
ind_slash=sci_find_simple(equation,'/',80)
//ind_percent=sci_find_simple(equation,'%',ind_percent,75)
ind_plus=sci_find_simple(equation,'+',70)
ind_minus=sci_find_simple(equation,'-',70)
//ind_tilde=sci_find_simple(equation,'~',ind_tilde,68)
//ind_pipe=sci_find_simple(equation,'|',ind_pipe,67)

//findtheindexesofequalkeywordspresentintheexaminedpartofequation
//[ind_equal,ind_doubleq,ind_diff,ind_supeq,ind_infeq]=sci_find_equal(equation,ind_equal,ind_doubleq,ind_diff,ind_supeq,ind_infeq)
ind_equal=sci_find_simple(equation,'=',10)

//ind_sup=sci_find_simple(equation,'>',ind_sup,55)
//ind_inf=sci_find_simple(equation,'<',ind_inf,55)

//findtheindexesofconditionalkeywordspresentintheexaminedpartofequation
//ind_not=sci_find_keywd(equation,'not',ind_not,['';')'],['';'('],49)
//ind_and=sci_find_keywd(equation,'and',ind_and,['';')'],['';'('],48)
//ind_or=sci_find_keywd(equation,'or',ind_or,['';')'],['';'('],47)
//ind_xor=sci_find_keywd(equation,'xor',ind_xor,['';')'],['';'('],46)
//ind_eqv=sci_find_keywd(equation,'eqv',ind_eqv,['';')'],['';'('],45)
//ind_column=sci_find_simple(equation,':',ind_column,35)
//ind_startcond=sci_find_keywd(equation,['if'],ind_startcond,[''],[],11)
//ind_startcond=sci_find_keywd(equation,['while'],ind_startcond,[''],[],11)
//ind_startcond=sci_find_keywd(equation,['until'],ind_startcond,[''],[],11)
//ind_startcond=sci_find_keywd(equation,['elseif'],ind_startcond,[''],[],11)
//ind_print=sci_find_keywd(equation,'print',ind_print,[''],[''],0)
ind_comma=sci_find_simple(equation,',',11)

//[junk,ind]=gsort(ind_startcond(1,:),'g','i')
//ind_startcond=ind_startcond(:,ind)
//
//[junk,ind]=gsort(ind_dotcond(1,:),'g','i')
//ind_dotcond=ind_dotcond(:,ind)

//for i=1:size(ind_bookkeep_transp,2)
//   ind_transp(:,ind_transp(1,:) == ind_bookkeep_transp(1,i))=[]
//end

//for i=1:size(ind_kron,2)
//   ind_matmul(:,ind_matmul(1,:) == ind_kron(1,i))=[]
//end

for i=1:size(ind_matmul,2)
   ind_star(:,ind_star(1,:) == ind_matmul(1,i)+1)=[]
end

for i=1:size(ind_matdiv,2)
   ind_slash(:,ind_slash(1,:) == ind_matdiv(1,i)+1)=[]
end

for i=1:size(ind_power,2)
   ind_hat(:,ind_hat(1,:) == ind_power(1,i))=[]
end

//for i=1:size(ind_supeq,2)
//   ind_sup(:,ind_sup(1,:) == ind_supeq(1,i))=[]
//end
//
//for i=1:size(ind_infeq,2)
//   ind_inf(:,ind_inf(1,:) == ind_infeq(1,i))=[]
//end

ind_unary=[]
for i=size(ind_minus,2):-1:1
  if ind_minus(1,i) == 1 then
     ind_unary=[ind_minus(:,i) ind_unary]
     ind_minus(:,i)=[]
   else
      stat_start=stripblanks(part(strcat(equation,' '),1:ind_minus(1,i)-1))
      length_start=length(stat_start)
      char_before_minus=part(stat_start,length_start)
      char_3before_minus=part(stat_start,max(1,length_start-2):length_start)
      char_4before_minus=part(stat_start,max(1,length_start-3):length_start)
      if or(char_before_minus == [ '[' ; '*' ; '~' ; ',' ; ';' ; '/' ;'+' ; ...
          '=' ; '<' ; '>' ; '.' ; ':' ; '(' ; '%' ; '^']) then
         ind_unary=[ind_minus(:,i) ind_unary]
         ind_minus(:,i)=[]
      end
   end
end

op=tlist(['op';'power';'hat';'unary';'star';'matmul';'slash';...
'matdiv';'plus';'minus';'equal';'comma';'all'],...
ind_power,ind_hat,ind_unary,ind_star,ind_matmul,ind_slash,...
ind_matdiv,ind_plus,ind_minus,ind_equal,ind_comma)

ind_all=[]
//ind_nonempty=[]
for i=2:length(op)-2
   ind_all=[ind_all op(i) ]
//   if ~isempty(op(i)) then
//      ind_nonempty=[ind_nonempty i]
//   end
end
//
//if ~isempty(ind_leftpar) then
//   ind_all=[ind_all ind_leftpar ind_rightpar]
//   ind_nonempty=[ind_nonempty length(op)-1]
//
//end
//if ~isempty(ind_leftbrack) then
//   ind_all=[ind_all ind_leftbrack ind_rightbrack]
//   ind_nonempty=[ind_nonempty length(op)]
//
//end


[junk,ind]=gsort(ind_all(1,:),'g','i')
ind_all=ind_all(:,ind)
op('all')=ind_all
//if ~isempty(ind_all) then
//   ind_nonempty=[ind_nonempty length(op)]
//end

endfunction
