function [ts1]=%ts_2_ts(ts1,ts2)
 
// PURPOSE: returns the ts equal to 1 over the dates where ts1
// > ts2 and 0 over the other ones
// ------------------------------------------------------------
// INPUT:
// * ts1 = a time series
// * ts2 = a time series
// ------------------------------------------------------------
// OUTPUT:
// * ts1 = the (0,1) resulting time series
// ------------------------------------------------------------
// NOTES:
// ------------------------------------------------------------
// Copyright: Eric Dubois 2002-2009
// http://dubois.ensae.net/grocer.html
 
f1=ts1('freq')
if f1 ~= ts2('freq') then
   error('timeseries have not the same frequency')
end
 
d1=ts1('dates')
d2=ts2('dates')
s1=ts1('series')
s2=ts2('series')
 
d1f=d1(1)
d1l=d1(size(d1,1))
d2f=d2(1)
d2l=d2(size(d2,1))
 
// determines the commun time span of the 2 series
datfirst=max(d1f,d2f)
datlast=min(d1l,d2l)
 
// for the sake of speed, fill the timeseries ts1 with the
// values of the product
ts1('dates')=[datfirst:datlast]'
ts1('series')=bool2s(s1(datfirst-d1f+1:datlast-d1f+1)...
              >s2(datfirst-d2f+1:datlast-d2f+1))
ts1(5)=''
 
endfunction
